/**
 * Copyright (c) 2021, 2024 Contributors to the Eclipse Foundation
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * generated by Xtext 2.22.0
 */
package org.eclipse.trace4cps.tl.etl.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.trace4cps.tl.etl.ApFormula;
import org.eclipse.trace4cps.tl.etl.EtlPackage;
import org.eclipse.trace4cps.tl.etl.MtlAp;
import org.eclipse.trace4cps.tl.etl.StlAp;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Ap Formula</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.ApFormulaImpl#getMtlAP <em>Mtl AP</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.ApFormulaImpl#getStlAP <em>Stl AP</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ApFormulaImpl extends FormulaImpl implements ApFormula
{
  /**
   * The cached value of the '{@link #getMtlAP() <em>Mtl AP</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMtlAP()
   * @generated
   * @ordered
   */
  protected MtlAp mtlAP;

  /**
   * The cached value of the '{@link #getStlAP() <em>Stl AP</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStlAP()
   * @generated
   * @ordered
   */
  protected StlAp stlAP;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ApFormulaImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return EtlPackage.Literals.AP_FORMULA;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public MtlAp getMtlAP()
  {
    return mtlAP;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMtlAP(MtlAp newMtlAP, NotificationChain msgs)
  {
    MtlAp oldMtlAP = mtlAP;
    mtlAP = newMtlAP;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.AP_FORMULA__MTL_AP, oldMtlAP, newMtlAP);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setMtlAP(MtlAp newMtlAP)
  {
    if (newMtlAP != mtlAP)
    {
      NotificationChain msgs = null;
      if (mtlAP != null)
        msgs = ((InternalEObject)mtlAP).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.AP_FORMULA__MTL_AP, null, msgs);
      if (newMtlAP != null)
        msgs = ((InternalEObject)newMtlAP).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.AP_FORMULA__MTL_AP, null, msgs);
      msgs = basicSetMtlAP(newMtlAP, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.AP_FORMULA__MTL_AP, newMtlAP, newMtlAP));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public StlAp getStlAP()
  {
    return stlAP;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetStlAP(StlAp newStlAP, NotificationChain msgs)
  {
    StlAp oldStlAP = stlAP;
    stlAP = newStlAP;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.AP_FORMULA__STL_AP, oldStlAP, newStlAP);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setStlAP(StlAp newStlAP)
  {
    if (newStlAP != stlAP)
    {
      NotificationChain msgs = null;
      if (stlAP != null)
        msgs = ((InternalEObject)stlAP).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.AP_FORMULA__STL_AP, null, msgs);
      if (newStlAP != null)
        msgs = ((InternalEObject)newStlAP).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.AP_FORMULA__STL_AP, null, msgs);
      msgs = basicSetStlAP(newStlAP, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.AP_FORMULA__STL_AP, newStlAP, newStlAP));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case EtlPackage.AP_FORMULA__MTL_AP:
        return basicSetMtlAP(null, msgs);
      case EtlPackage.AP_FORMULA__STL_AP:
        return basicSetStlAP(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case EtlPackage.AP_FORMULA__MTL_AP:
        return getMtlAP();
      case EtlPackage.AP_FORMULA__STL_AP:
        return getStlAP();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case EtlPackage.AP_FORMULA__MTL_AP:
        setMtlAP((MtlAp)newValue);
        return;
      case EtlPackage.AP_FORMULA__STL_AP:
        setStlAP((StlAp)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.AP_FORMULA__MTL_AP:
        setMtlAP((MtlAp)null);
        return;
      case EtlPackage.AP_FORMULA__STL_AP:
        setStlAP((StlAp)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.AP_FORMULA__MTL_AP:
        return mtlAP != null;
      case EtlPackage.AP_FORMULA__STL_AP:
        return stlAP != null;
    }
    return super.eIsSet(featureID);
  }

} //ApFormulaImpl
